/*
 * Avisynth checker
 * MobileHackerz http://www.nurs.or.jp/~calcium/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <windows.h>

int check_avs(char *errmsg,int errmsglen)
{
	HMODULE		avsdll;
	void *(* avs_create)();
	int __stdcall (* avs_open)(void *,char *,void *);
	int __stdcall (* avs_getvframe)(void *avs, int clip_num, int frm, void *vf);
	int __stdcall (* avs_getaframe)(void *avs, int clip_num, void *buf, void *pos);
	int __stdcall (* avs_close)(void *avs, int clip_num);
	int __stdcall (* avs_getlasterror)(char *str,int len);
	void *ctx;

	// ----------------- load DLL
	avsdll                 = LoadLibrary("AVSredirect.dll");
	if (!avsdll)           { strncpy(errmsg,"failed to load AVSredirect.dll",errmsglen-1); return 0; }
	avs_create             = (void *(*)()) GetProcAddress(avsdll, "_avs_create@0");
	if (!avs_create)       { strncpy(errmsg,"failed to load avs_create",errmsglen-1); return 0; }
	avs_open               = (int __stdcall (*)(void *,char *,void *)) GetProcAddress(avsdll, "_avs_open@12");
	if (!avs_open)         { strncpy(errmsg,"failed to load avs_open",errmsglen-1); return 0; }
	avs_getvframe          = (int __stdcall (*)(void *,int,int,void *)) GetProcAddress(avsdll, "_avs_getvframe@16");
	if (!avs_getvframe)    { strncpy(errmsg,"failed to load avs_getvframe",errmsglen-1); return 0; }
	avs_getaframe          = (int __stdcall (*)(void *, int, void *, void *)) GetProcAddress(avsdll, "_avs_getaframe@16");
	if (!avs_getaframe)    { strncpy(errmsg,"failed to load avs_getaframe",errmsglen-1); return 0; }
	avs_close              = (int __stdcall (*)(void *, int)) GetProcAddress(avsdll, "_avs_close@8");
	if (!avs_close)        { strncpy(errmsg,"failed to load avs_close",errmsglen-1); return 0; }
	avs_getlasterror       = (int __stdcall (*)(char *, int)) GetProcAddress(avsdll, "_avs_getlasterror@8");
	if (!avs_getlasterror) { strncpy(errmsg,"failed to load avs_getlasterror",errmsglen-1); return 0; }

	// ----------------- open
	ctx = avs_create();
	if (!ctx) { 
		avs_getlasterror(errmsg,errmsglen);
		return 0;
	}
	return 1;
}


int main(int argc, char *argv[]) 
{
	char errmsg[1024];
	int r = check_avs(errmsg,1024);
	if (r == 0) printf("T>%s\n",errmsg);

	return r;
}
